#!/usr/bin/perl
#
#    Webmin module for Exim
#    Copyright (C) 2001 by Alexandre MATHIEU <mtlx@free.fr>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#
# dspl_log.cgi
# Display the selected log file

require 5;

use strict;
use integer;
use vars qw(%config %in %text);

require './exim-lib.pl';

ReadParse();

my @logs = ( 'main', 'panic', 'reject' );

my $log = $config{log_default};
my $lines = $config{log_lines};

if (exists $in{log})
  {
    $log = parse_CGI ($in{log}, 8, 'a-z', @logs)
  }

header($text{log_title}, '');
print '<hr/>', "\n";

log_links($log);

my $logfile = get_log_directory();
$logfile =~ s/%s/$log/;

if (exists $in{lines})
  {
    my $temp_lines = parse_CGI ($in{lines}, 4, '0-9');
    $lines = $temp_lines if defined $temp_lines
  }

print '<pre>', "\n";
open LOG, "tail -$lines $logfile|" or die "Unable to open log file: $logfile\n";
while (<LOG>)
  {
    print '  ', HTML_entities ($_);
  }
close LOG;
print '</pre>', "\n";

print '<form action="dspl_log.cgi" method="post">', "\n";

print &text ('log_info',
	     "<input type=\"text\" name=\"lines\" size=\"3\" value=\"$lines\">",
	     "<tt>$logfile</tt>"), "\n";
print "<input type=\"submit\" value=\"$text{log_refresh}\"><br/>\n";
print '</form><hr>', "\n";

footer('', $text{index_title});
1;

sub log_links
{
  my $current_log = shift;

  print '<b>', $text{log_choose}, ':</b>&nbsp;&nbsp;', "\n";
  foreach my $log (@logs)
    {
      if ($log ne $current_log)
	{
	  print "<a href=\"dspl_log.cgi?log=$log\">$log</a>"
	}
      else
	{
	  print '<b>', $current_log, '</b>'
	}
      print '&nbsp;', "\n"
    }
  print '<hr/>', "\n"
}
