#!/usr/bin/perl
#
#    Webmin module for Exim
#    Copyright (C) 2001 by Alexandre MATHIEU <mtlx@free.fr>
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#
# proc_msg.cgi
# process a message

require 5;

use strict;
use integer;
use vars qw{%msg_actions %in %config %text};

require './spool-lib.pl';

ReadParse();

# Check the CGIs 'msg_id' and 'action' syntax and eventually perform a redirection.
my $msg_id = parse_CGI ($in{msg_id}, 16, 'A-Za-z0-9\-');

defined $msg_id and $msg_id =~ /^(?:\w{6}-){2}\d{2}$/
  or redirect("/$::module_name/dspl_spool.cgi"), exit();

my $action;
foreach (keys %msg_actions)
  {
    if (defined $in{$_})
      {
	$action = $_;
	last
      }
  }
defined $action	or redirect("/$::module_name/dspl_spool.cgi"), exit();

# Webmin header
header($msg_id, '');
print '<hr/>', "\n";

print '<table border>', "\n";

my @addrs;
ACTION: {
  my $cgi = $msg_actions{$action}->{cgi} or last ACTION;
  defined $in{$cgi} or last ACTION;
  push @addrs, $in{$cgi};
  # !!!! vrifier les caractre autoris dans la RFC822 (?)
  map { $_ =~ tr/a-zA-Z0-9\-_\.\@//c } @addrs;
}

my @command;
push @command, '-v' if $config{verbose};
push @command, $msg_actions{$action}->{cmd};
push @command, $msg_id;
push @command, @addrs if @addrs;
my $command = join ' ', @command;

print_th ($text{msg_command});
print_tr ("$config{exim_path} $command");
print_th ($text{msg_result});
print "<tr $::cb>", '<td>', "\n";

my $exim = cast_exim (undef, $command, '2>&1') or die('Unable to fork');
my $first_line = <$exim>;
chomp $first_line;
print $first_line if not $first_line =~ /^$msg_id/;
print join '<br/>', <$exim>;
close $exim or die ('Unexpected pb');
print '</td>', '</tr>', "\n";

print '</table>', "\n";
print '<p/>', '<hr/>', "\n";
footer("./dspl_msg.cgi?msg_id=$msg_id", $msg_id);
1;
